package com.rjconsultores.integracaoreceitadespesa;

import java.io.FileInputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Properties;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


public class Application {
	private static Application instance = null;
	
	private static final Logger log = LogManager.getLogger(Application.class);
	
	private Application(){
		
	}
	
	public Connection getConnection(){
		try {
			Properties props = Application.getInstance().getApplicationProperties();
			
			String DRIVER = "oracle.jdbc.driver.OracleDriver"; 
			 
			Class.forName(DRIVER); 
			Connection conn = DriverManager.getConnection(
					props.getProperty("url"), 
					props.getProperty("username").trim(), 
					props.getProperty("password").trim()); 
			
			return conn;
			
		} catch (Exception e){
			log.error("", e);
			return null;
		}
	}
	public static Application getInstance(){
		if (instance == null){
			instance = new Application();
		}
		return instance;
	}
	
	public Properties getApplicationProperties(){
		Properties props = new Properties();
		try {
			props.load(new FileInputStream("db.properties"));
		} catch (IOException e) {
			log.error("", e);
		}
		return props;
	}	
}
